﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ReaderB;

namespace usb930Demo
{
    public partial class Form1 : Form
    {
        const int _epc = 1;
        const int _times = 2;

        private byte fComAdr = 0xff; //当前操作的ComAdr
        private int ferrorcode;
        private byte fBaud;
        private double fdminfre;
        private double fdmaxfre;
        private int fCmdRet = 30; //所有执行指令的返回值
        private byte[] fOperEPC = new byte[36];
        private byte[] fPassWord = new byte[4];
        private byte[] fOperID_6B = new byte[8];
        private int frmcomportindex;
        private bool ComOpen = false;

        bool Reading=false ;
        bool Closeing = false;
        string[] CardNo = new string[1];

        bool ReadData = false;

        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            string[] comname = System.IO.Ports.SerialPort.GetPortNames();
            for (int tmp1 = 0; tmp1 < comname.Length; tmp1++)
            {
                ComboBox_COM.Items.Add(comname[tmp1]);
            }
            string tmp = DataBase.GetFromini("set", "l1");
            if (string.IsNullOrEmpty(tmp) == false)
            {
                l1.Text = tmp;
            }
            tmp = DataBase.GetFromini("set", "l2");
            if (string.IsNullOrEmpty(tmp) == false)
            {
                l2.Text = tmp;
            }
            tmp = DataBase.GetFromini("set", "l3");
            if (string.IsNullOrEmpty(tmp) == false)
            {
                l3.Text = tmp;
            }
            tmp = DataBase.GetFromini("set", "l4");
            if (string.IsNullOrEmpty(tmp) == false)
            {
                l4.Text = tmp;
            }
        }
        private void OpenPort_Click(object sender, EventArgs e)
        {
            int port = 0;
            int openresult, i;
            openresult = 30;
            string temp;
            Cursor = Cursors.WaitCursor;
            fComAdr =Convert.ToByte("FF", 16); // $FF;
            try
            {
                for (int index = ComboBox_COM.Items.Count - 1; index >= 0; index--)
                {
                    temp = ComboBox_COM.Items[index].ToString();
                    port = Convert.ToInt32(temp.Substring(3, temp.Length - 3));
                    for (i = 6; i >= 0; i--)
                    {
                        fBaud = Convert.ToByte(i);
                        if (fBaud == 3) continue;
                        openresult = StaticClassReaderB.OpenComPort(port, ref fComAdr, fBaud, ref frmcomportindex);
                        if (openresult == 0x35)
                        {
                            MessageBox.Show("COM Opened", "Information");
                            return;
                        }
                        else if (openresult == 0)
                        {
                            ComOpen = true;
                            GetReaderInfo(); //自动执行读取写卡器信息
                            if ((fCmdRet == 0x35) || (fCmdRet == 0x30))
                            {
                                ComOpen = false;
                                MessageBox.Show("Serial Communication Error or Occupied", "Information");
                                StaticClassReaderB.CloseSpecComPort(frmcomportindex);
                                return;
                            }
                            OpenPort.Enabled = false;
                            ClosePort.Enabled = listView1.Enabled = groupBox3.Enabled = groupBox4.Enabled = true;
                            return;
                        }
                    }
                }
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }
        private void ClosePort_Click(object sender, EventArgs e)
        {
            while (Reading)
            {
                Application.DoEvents();
            }
            Closeing = true;
            fCmdRet = StaticClassReaderB.CloseComPort();
            if (fCmdRet == 0)
            {
                timer1.Enabled = false;
                ComOpen = false;
                OpenPort.Enabled = true;
                ClosePort.Enabled = listView1.Enabled = groupBox3.Enabled = groupBox4.Enabled = false;
                button1.Text = "Read";
                clearinfo();
            }
            Closeing = false;
        }
        private void GetReaderInfo()
        {
            byte[] TrType = new byte[2];
            byte[] VersionInfo = new byte[2];
            byte ReaderType = 0;
            byte ScanTime = 0;
            byte dmaxfre = 0;
            byte dminfre = 0;
            byte powerdBm = 0;
            byte FreBand = 0;
            clearinfo();
            fCmdRet = StaticClassReaderB.GetReaderInformation(ref fComAdr, VersionInfo, ref ReaderType, TrType, ref dmaxfre, ref dminfre, ref powerdBm, ref ScanTime, frmcomportindex);
            if (fCmdRet == 0)
            {
                Edit_Version.Text = Convert.ToString(VersionInfo[0], 10).PadLeft(2, '0') + "." + Convert.ToString(VersionInfo[1], 10).PadLeft(2, '0');
                Edit_ComAdr.Text = Convert.ToString(fComAdr, 16).PadLeft(2, '0');
                Edit_scantime.Text = Convert.ToString(ScanTime, 10).PadLeft(2, '0') + "*100ms";
                Edit_powerdBm.Text = Convert.ToString(powerdBm, 10).PadLeft(2, '0');
                FreBand = Convert.ToByte(((dmaxfre & 0xc0) >> 4) | (dminfre >> 6));
                switch (FreBand)
                {
                    case 0:
                        {
                            fdminfre = 902.6 + (dminfre & 0x3F) * 0.4;
                            fdmaxfre = 902.6 + (dmaxfre & 0x3F) * 0.4;
                        }
                        break;
                    case 1:
                        {
                            fdminfre = 920.125 + (dminfre & 0x3F) * 0.25;
                            fdmaxfre = 920.125 + (dmaxfre & 0x3F) * 0.25;
                        }
                        break;
                    case 2:
                        {
                            fdminfre = 902.75 + (dminfre & 0x3F) * 0.5;
                            fdmaxfre = 902.75 + (dmaxfre & 0x3F) * 0.5;
                        }
                        break;
                    case 3:
                        {
                            fdminfre = 917.1 + (dminfre & 0x3F) * 0.2;
                            fdmaxfre = 917.1 + (dmaxfre & 0x3F) * 0.2;
                        }
                        break;
                }
                Edit_dminfre.Text = Convert.ToString(fdminfre) + "MHz";
                Edit_dmaxfre.Text = Convert.ToString(fdmaxfre) + "MHz";

                if (ReaderType == 0x03) Edit_Type.Text = "";
                if (ReaderType == 0x06) Edit_Type.Text = "";
                if (ReaderType == 0x09) Edit_Type.Text = "DL920";

                if (Edit_Type.Text == "")
                {
                    Edit_Type.Text = "DL9700";
                }

                if ((TrType[0] & 0x02) == 0x02) //第二个字节低第四位代表支持的协议“ISO/IEC 15693”
                {
                    ISO180006B.Checked = true;
                    EPCC1G2.Checked = true;
                }
                else
                {
                    ISO180006B.Checked = false;
                    EPCC1G2.Checked = false;
                }
            }
        }
        private void clearinfo()
        {
            Edit_Version.Text = "";
            Edit_ComAdr.Text = "";
            Edit_Type.Text = "";
            Edit_powerdBm.Text = "";
            Edit_dminfre.Text = "";
            Edit_dmaxfre.Text = "";
            Edit_scantime.Text = "";
            ISO180006B.Checked = false;
            EPCC1G2.Checked = false;
            listView1.Items.Clear();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (Closeing || Reading) { return; }
            Reading = true;
            if (GetEPCTxt())
            {
                int index = -1;
                for (int tmp = 0; tmp < CardNo.Length; tmp++)
                {
                    foreach (ListViewItem item in listView1.Items)
                    {
                        if (item.SubItems[_epc].Text == CardNo[tmp])
                        {
                            item.SubItems[_times].Text = (int.Parse(item.SubItems[_times].Text) + 1).ToString();
                            index = item.Index;
                        }
                    }
                    if (index < 0)
                    {
                        ListViewItem newitem = new ListViewItem((listView1.Items.Count + 1).ToString());
                        newitem.SubItems.Add(CardNo[tmp]);
                        newitem.SubItems.Add("1");
                        listView1.Items.Add(newitem);
                        index = listView1.Items.Count - 1;
                    }
                    listView1.EnsureVisible(index);
                    if (ReadData)
                    {
                        marktxt.Text = "";
                        label1.Focus();
                        tagid.Text = CardNo[0];
                        if (readdata(tagid.Text))
                        {
                            label1.Text = "\r\n\r\n" + l1.Text + ":" + tagid.Text + "\r\n\r\n";
                            label1.Text += l2.Text + ":" + textBox1.Text + "\r\n\r\n";
                            label1.Text += l3.Text + ":" + textBox2.Text + "\r\n\r\n";
                            label1.Text += l4.Text + ":" + textBox3.Text;
                            if (this.WindowState == FormWindowState.Minimized)
                            {
                                notifyIcon1.Visible = true;
                                notifyIcon1.ShowBalloonTip(10000, this.Text, label1.Text, ToolTipIcon.Info);
                            }
                        }
                    }
                }
            }
            Reading = false;
        }
        private bool GetEPCTxt()
        {
            int CardNum = 0;
            int Totallen = 0;
            byte[] EPC = new byte[1024];
            int fCmdRet = StaticClassReaderB.Inventory_G2(ref fComAdr, EPC, ref Totallen, ref CardNum, frmcomportindex);
            if ((fCmdRet == 1) | (fCmdRet == 2) | (fCmdRet == 3) | (fCmdRet == 4) | (fCmdRet == 0xFB))//代表已查找结束，
            {
                if (CardNum == 0) return false;       //接收卡数为0
                byte[] daw = new byte[Totallen];
                Array.Copy(EPC, daw, Totallen);
                string temps = ByteArrayToHexString(daw);

                int m = 0, EPClen;
                Array.Resize(ref CardNo, CardNum);        //重新定义数组大小(维数)
                for (int CardIndex = 0; CardIndex < CardNum; CardIndex++)
                {
                    EPClen = daw[m];
                    CardNo[CardIndex] = temps.Substring(m * 2 + 2, EPClen * 2);
                    m = m + EPClen + 1;
                    if (CardNo[CardIndex].Length != EPClen * 2) { return false; }
                }
                return true;
            }
            return false;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
            {
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            }
            return sb.ToString().ToUpper();
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                int index = listView1.SelectedIndices[0];
                tagid .Text  = listView1.Items[index].SubItems[_epc].Text;
            }
            catch { }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            button3.Enabled = false;
            while (Reading)
            {
                Application.DoEvents();
            }
            Reading = true;
            writedata();
            Reading = false;
            button3.Enabled = true;
        }
        private void writedata()
        {
            string Data = "";
            if (tagid.Text.Trim() == "") return;
            Data = textBox1.Text.Trim() + "\t" + textBox2.Text.Trim() + "\t" + textBox3.Text+"\t\t";
            if (Data == "\t\t") { return; }

            byte WordPtr, ENum;
            byte Mem = 0, EPClength = 0, Writedatalen = 0;
            int WrittenDataNum = 0;
            string s2, str;
            byte Maskadr = 0, MaskLen = 0, MaskFlag = 0;

            str = tagid.Text;
            ENum = Convert.ToByte(str.Length / 4);
            EPClength = Convert.ToByte(ENum * 2);
            byte[] EPC = new byte[ENum];
            EPC = HexStringToByteArray(str);
            Mem = 3;  //用户区
            WordPtr = 00;
            byte[] fPassWord = HexStringToByteArray("00000000");
            s2 = Data;

            byte[] Writedata = System.Text.Encoding.Default.GetBytes(s2);
            if (Writedata.Length % 2 != 0)
            {
                int length = Writedata.Length + 1;
                Array.Resize(ref Writedata, length);
            }
            Writedatalen = Convert.ToByte(Writedata.Length);
            for (int count = 0; count < 5; count++)
            {
                int fCmdRet = StaticClassReaderB.WriteCard_G2(ref fComAdr, EPC, Mem, WordPtr, Writedatalen, Writedata, fPassWord, Maskadr, MaskLen, MaskFlag, WrittenDataNum, EPClength, ref ferrorcode, frmcomportindex);
                if (fCmdRet == 0)
                {
                    marktxt.Text = DateTime.Now.ToString() + " Write success";
                    marktxt.ForeColor = Color.Blue;
                    return;
                }
            }
            marktxt.Text = DateTime.Now.ToString() + " Write Fail";
            marktxt.ForeColor = Color.Red;
        }
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Enabled = !timer1.Enabled;
            if (timer1.Enabled==false)
            {
                groupBox3.Enabled = true;
                button1.Text = "Read";
            }
            else
            {
                button1.Text = "Stop";
                groupBox3.Enabled = false;
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;
            while (Reading)
            {
                Application.DoEvents();
            }
            Reading = true;
            readdata(tagid.Text);
            Reading = false;
            button2.Enabled = true;
        }
        private bool readdata(string tagid)
        {
            textBox1.Text = "";
            textBox2.Text = "";
            textBox3.Text = "";
            marktxt.Text = "";
            if (tagid.Trim() == "") return false ;

            byte WordPtr;
            byte Mem = 0, EPClength = 0;
            byte Num = 32;
            string str;
            byte Maskadr = 0, MaskLen = 0, MaskFlag = 0;
            byte[] CardData = new byte[128];

            str = tagid;
            EPClength = Convert.ToByte(str.Length / 2);
            byte[] EPC = new byte[EPClength];
            EPC = HexStringToByteArray(str);

            Mem = 3;  //用户区
            WordPtr = 00;  //起始地址
            byte[] fPassWord = HexStringToByteArray("00000000");
            for (int count = 0; count < 3; count++) 
            {
                int fCmdRet = StaticClassReaderB.ReadCard_G2(ref fComAdr, EPC, Mem, WordPtr, Num, fPassWord, Maskadr, MaskLen, MaskFlag, CardData, EPClength, ref ferrorcode, frmcomportindex);
                if (fCmdRet == 0)
                {
                    string s3 = null;
                    s3 = Encoding.Default.GetString(CardData);
                    int index = s3.IndexOf("\t\t");
                    if (index > 0)
                    {
                        s3 = s3.Substring(0, index);
                        string[] str1 = s3.Split('\t');
                        if (str1.Length > 0) textBox1.Text = str1[0];
                        if (str1.Length > 1) textBox2.Text = str1[1];
                        if (str1.Length > 2) textBox3.Text = str1[2];
                    }
                    marktxt.Text = DateTime.Now.ToString() + " Read data success";
                    marktxt.ForeColor = Color.Blue;
                    return true;
                }
            }
            marktxt.Text = DateTime.Now.ToString() + " Read data fail";
            marktxt.ForeColor = Color.Red;
            return false; ;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            ReadData = checkBox1.Checked;
            if (ReadData)
            {
                listView1.Visible = false;
                groupBox3.Visible = false ;
                groupBox4.Width = groupBox3.Left + groupBox3.Width - groupBox4.Left;
            }
            else
            {
                listView1.Visible = true;
                groupBox3.Visible = true;
                groupBox4.Width = groupBox3.Left - groupBox4.Left - 8;
            }
        }
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                notifyIcon1.Visible = true;
                notifyIcon1.ShowBalloonTip(10000, this.Text, "Hi", ToolTipIcon.Info); 
            }
            else
            {
                notifyIcon1.Visible = false;
            }

        }

        private void notifyIcon1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                notifyIcon1_BalloonTipClicked(null, null);
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            notifyIcon1.Visible = false;
        }

        private void notifyIcon1_BalloonTipClicked(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            notifyIcon1.Visible = false;
        }

        private void l1_DoubleClick(object sender, EventArgs e)
        {
            Label label = (Label)sender;
            frmsettxt frm = new frmsettxt();
            frm.textBox1.Text = label.Text;
            if (frm.ShowDialog(this) != DialogResult.OK) return;
            label.Text = frm.textBox1.Text.Trim();
            DataBase.SaveToini("set", label.Name, label.Text);
        }
    }
}
